# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: "http://devicetree.org/schemas/phy/qcom,usb-snps-femto-v2.yaml#"
$schema: "http://devicetree.org/meta-schemas/core.yaml#"

title: Qualcomm Synopsys Femto High-Speed USB PHY V2

maintainers:
  - Wesley Cheng <quic_wcheng@quicinc.com>

description: |
  Qualcomm High-Speed USB PHY

properties:
  compatible:
    oneOf:
      - enum:
          - qcom,sc8180x-usb-hs-phy
          - qcom,usb-snps-femto-v2-phy
      - items:
          - enum:
              - qcom,sc8280xp-usb-hs-phy
          - const: qcom,usb-snps-hs-5nm-phy
      - items:
          - enum:
              - qcom,sc7280-usb-hs-phy
              - qcom,sdx55-usb-hs-phy
              - qcom,sdx65-usb-hs-phy
              - qcom,sm6375-usb-hs-phy
              - qcom,sm8150-usb-hs-phy
              - qcom,sm8250-usb-hs-phy
              - qcom,sm8350-usb-hs-phy
              - qcom,sm8450-usb-hs-phy
          - const: qcom,usb-snps-hs-7nm-phy

  reg:
    maxItems: 1

  "#phy-cells":
    const: 0

  clocks:
    items:
      - description: rpmhcc ref clock

  clock-names:
    items:
      - const: ref

  resets:
    items:
      - description: PHY core reset

  vdda-pll-supply:
    description: phandle to the regulator VDD supply node.

  vdda18-supply:
    description: phandle to the regulator 1.8V supply node.

  vdda33-supply:
    description: phandle to the regulator 3.3V supply node.

  qcom,hs-disconnect-bp:
    description:
      This adjusts the voltage level for the threshold used to
      detect a disconnect event at the host.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: -272
    maximum: 2156

  qcom,squelch-detector-bp:
    description:
      This adjusts the voltage level for the threshold used to
      detect valid high-speed data.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: -2090
    maximum: 1590

  qcom,hs-amplitude-bp:
    description:
      This adjusts the high-speed DC level voltage.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: -660
    maximum: 2670

  qcom,pre-emphasis-duration-bp:
    description:
      This signal controls the duration for which the
      HS pre-emphasis current is sourced onto DP<#> or DM<#>.
      The HS Transmitter pre-emphasis duration is defined in terms of
      unit amounts. One unit of pre-emphasis duration is approximately
      650 ps and is defined as 1X pre-emphasis duration.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: 10000
    maximum: 20000

  qcom,pre-emphasis-amplitude-bp:
    description:
      This signal controls the amount of current sourced to
      DP<#> and DM<#> after a J-to-K or K-to-J transition.
      The HS Transmitter pre-emphasis current is defined in terms of unit
      amounts. One unit amount is approximately 2 mA and is defined as
      1X pre-emphasis current.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: 10000
    maximum: 40000

  qcom,hs-rise-fall-time-bp:
    description:
      This adjusts the rise/fall times of the high-speed waveform.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: -4100
    maximum: 5430

  qcom,hs-crossover-voltage-microvolt:
    description:
      This adjusts the voltage at which the DP<#> and DM<#>
      signals cross while transmitting in HS mode.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: -31000
    maximum: 28000

  qcom,hs-output-impedance-micro-ohms:
    description:
      In some applications, there can be significant series resistance
      on the D+ and D- paths between the transceiver and cable. This adjusts
      the driver source impedance to compensate for added series
      resistance on the USB. The hardware accepts only discrete values. The
      value closest to the provided input will be chosen as the override value
      for this param.
    minimum: -2300000
    maximum: 6100000

  qcom,ls-fs-output-impedance-bp:
    description:
      This adjusts the low- and full-speed single-ended source
      impedance while driving high. The following adjustment values are based
      on nominal process, voltage, and temperature.
      The hardware accepts only discrete values. The value closest to the
      provided input will be chosen as the override value for this param.
    minimum: -1053
    maximum: 1310

required:
  - compatible
  - reg
  - "#phy-cells"
  - clocks
  - clock-names
  - resets
  - vdda-pll-supply
  - vdda18-supply
  - vdda33-supply

additionalProperties: false

examples:
  - |
    #include <dt-bindings/clock/qcom,rpmh.h>
    #include <dt-bindings/clock/qcom,gcc-sm8150.h>
    phy@88e2000 {
        compatible = "qcom,sm8150-usb-hs-phy", "qcom,usb-snps-hs-7nm-phy";
        reg = <0x088e2000 0x400>;
        #phy-cells = <0>;

        clocks = <&rpmhcc RPMH_CXO_CLK>;
        clock-names = "ref";

        resets = <&gcc GCC_QUSB2PHY_PRIM_BCR>;

        vdda-pll-supply = <&vdd_usb_hs_core>;
        vdda33-supply = <&vdda_usb_hs_3p1>;
        vdda18-supply = <&vdda_usb_hs_1p8>;
    };
...
